"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  dismissLogic: () => dismissLogic
});
module.exports = __toCommonJS(src_exports);
var import_dismissible_layer = require("@react-dive-ui/dismissible-layer");
var import_xstate = require("xstate");
var dismissLogic = (0, import_xstate.fromCallback)(
  ({ input }) => {
    const cleanups = [];
    const rId = requestAnimationFrame(() => {
      const element = input.getElement();
      if (!element)
        return;
      const excludeElements = (input.exclude ?? []).map((v) => typeof v === "function" ? v() : v).filter((v) => !!v);
      cleanups.push(() => cancelAnimationFrame(rId));
      cleanups.push(
        (0, import_dismissible_layer.dismissHandler)({
          layer: {
            element,
            dismiss: input.dismiss,
            modal: input.modal
          },
          options: {
            exclude: excludeElements
          }
        })
      );
    });
    return () => {
      cleanups.forEach((cleanup) => cleanup());
    };
  }
);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  dismissLogic
});
