// src/index.ts
import { dismissHandler } from "@react-dive-ui/dismissible-layer";
import { fromCallback } from "xstate";
var dismissLogic = fromCallback(
  ({ input }) => {
    const cleanups = [];
    const rId = requestAnimationFrame(() => {
      const element = input.getElement();
      if (!element)
        return;
      const excludeElements = (input.exclude ?? []).map((v) => typeof v === "function" ? v() : v).filter((v) => !!v);
      cleanups.push(() => cancelAnimationFrame(rId));
      cleanups.push(
        dismissHandler({
          layer: {
            element,
            dismiss: input.dismiss,
            modal: input.modal
          },
          options: {
            exclude: excludeElements
          }
        })
      );
    });
    return () => {
      cleanups.forEach((cleanup) => cleanup());
    };
  }
);
export {
  dismissLogic
};
